package com.bocloud.sms.interfaces;

import com.bocloud.sms.entity.Label;
import com.megatron.common.model.*;

/**
 * @author tyl
 */
public interface LabelService {

    /**
     * 查询标签列表
     *
     * @param pager
     * @param context
     * @return
     */
    GeneralResult<GridBean<Label>> list(Pager pager, RequestContext context);

    /**
     * 查看标签详情
     *
     * @param id
     * @return
     */
    GeneralResult<Label> detail(Long id);

    /**
     * 创建标签
     *
     * @param label
     * @param context
     * @return
     */
    GeneralResult<Label> create(Label label, RequestContext context);

    /**
     * 更新标签
     *
     * @param label
     * @return
     */
    GeneralResult<Label> modify(Label label);

    /**
     * 删除标签
     *
     * @param id
     * @return
     */
    Result remove(Long id);

}
