package com.bocloud.sms.service;

import cn.hutool.core.lang.Assert;
import com.alibaba.fastjson.JSONObject;
import com.bocloud.sms.entity.SystemConfig;
import com.bocloud.sms.interfaces.SystemHomeService;
import com.bocloud.sms.repository.SystemConfigRepository;
import com.megatron.common.enums.PostDataFormat;
import com.megatron.common.http.HttpClient;
import com.megatron.common.model.GeneralResult;
import com.megatron.common.model.Result;
import com.megatron.common.utils.MapTools;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Map;

@Slf4j
@Service
public class SystemHomeServiceImpl implements SystemHomeService {

    @Autowired
    private SystemConfigRepository systemConfigRepository;

    @Override
    public GeneralResult<?> getToken() {
        String sessionId = null;
        SystemConfig addr = systemConfigRepository.queryByCode("winhongUrl");
        SystemConfig name = systemConfigRepository.queryByCode("winhongName");
        SystemConfig password = systemConfigRepository.queryByCode("winhongPwd");
        Assert.isTrue(null != addr && null != name && null != password,"云宏系统参数缺失");

        HttpClient client = new HttpClient();
        client.setDataFormat(PostDataFormat.RAW);
        Map<String, Object> param = MapTools.simpleMap("user", name.getValue());
        param.put("pwd", password.getValue());
        log.info("请求{}参数为:{} ", addr.getValue() + "/api/login", JSONObject.toJSONString(param));
        Result response = client.post(null, param, addr.getValue() + "/api/login");
        log.info("获取云宏token接口返回 {}", JSONObject.toJSONString(response));
        if (response.isSuccess()) {
            JSONObject loginRsp = JSONObject.parseObject(response.getMessage());
            sessionId = loginRsp.getString("sessionId");
        } else {
            log.error("Init Error:{}", JSONObject.toJSONString(response));
        }

        return new GeneralResult<>(true, sessionId, "获取云宏token成功");
    }

    public static void main(String[] args) {
        SystemHomeServiceImpl systemHomeServer = new SystemHomeServiceImpl();
        GeneralResult<?> token = systemHomeServer.getToken();

    }
}
