package com.bocloud.sms.service.utils;

import cn.hutool.http.HttpUtil;
import com.alibaba.fastjson.JSONObject;
import com.bocloud.sms.enums.YkInf;
import com.bocloud.sms.model.YkReqVo;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

@Component
public class YkUtils {
    private final Logger logger = LoggerFactory.getLogger(this.getClass());
	//参考application.yml配置文件
    @Value("${yk.url:http://36.111.150.83:9527/}")
    private String url;

    @Value("${yk.reqUserId:1}")
    private String reqUserId;

    @Value("${yk.systemId:1}")
    private String systemId;


    public <T>  T call(YkInf inf, JSONObject params, Class expectCls){
        YkReqVo reqVo = new YkReqVo(reqUserId,systemId,inf.getUrl(),params);
        String str = JSONObject.toJSONString(reqVo);
        logger.info("call yk url [{}]" , url);
        logger.info("call yk method[{}] req params[{}]",reqVo.getMethod(),str);
        String resultStr = HttpUtil.post(url, str, 10000);
        //logger.info("call method[{}] resp params[{}]",reqVo.getMethod(),resultStr);
        JSONObject result = JSONObject.parseObject(resultStr);
        logger.info("call yk result [{}]" , result.toString());

        if (result.getInteger("returnCode") != 1) {
            throw new IllegalArgumentException("调用运控接口异常" + result.getString("msg"));
        }
        if(JSONObject.class.equals(expectCls)){
            return (T)result.getJSONObject("data");
        }else{
            return (T)result.getString("data");
        }

    }
}
