package com.bocloud.sms.entity;

import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.megatron.common.model.RequestContext;
import com.megatron.common.utils.DateDeserializer;
import com.megatron.common.utils.DateSerializer;
import com.megatron.entity.annotations.*;
import com.megatron.entity.bean.Generic;
import com.megatron.entity.meta.PKStrategy;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * 审计日志信息类
 *
 * @author dmw
 */
@Data
@EqualsAndHashCode(callSuper = true)
@AllArgsConstructor
@NoArgsConstructor
@Table("access_log")
public class AccessLog extends Generic {

    @PK(value = PKStrategy.UUID)
    private String id;
    @Column("target")
    private String target;
    @Column("action")
    private String action;
    @Column("result")
    private String result;
    @Column("user_id")
    private Long userId;
    @Column("response_ip")
    private String responseIp;
    @Column("request_ip")
    private String requestIp;
    @Column("request_id")
    private String requestId;
    @Column(value = "gmt_create", nullable = false)
    @IgnoreUpdate
    @JsonSerialize(using = DateSerializer.class)
    @JsonDeserialize(using = DateDeserializer.class)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date gmtCreate;
    @Column("cost")
    private Long cost;
    @Column("detail")
    private String detail;
    @Column("module")
    private String module;
    @Column("tenant_id")
    private Long tenantId;
    @Column("catalog")
    private RequestContext.Catalog catalog;
    @IgnoreUpdate
    @IgnoreInsert
    private String account;
    @IgnoreAll
    private String userName;

}