package com.bocloud.sms.entity;

import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.IgnoreAll;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.GenericEntity;
import com.megatron.entity.meta.PKStrategy;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

import java.util.List;

/**
 * 自服务端权限实体类
 *
 * @author wangyu
 * @version 1.0
 * @since 2020年1月29日
 */
@Data
@NoArgsConstructor
@AllArgsConstructor
@EqualsAndHashCode(callSuper = true)
@Table("permission")
public class Permission extends GenericEntity {

    @PK(value = PKStrategy.AUTO)
    private Long id;
    /**
     * 父节点
     */
    @Column("parent_id")
    private Long parentId;
    /**
     * 是否为租户权限
     */
    @Column("is_tenant")
    private Boolean tenant;
    /**
     * 路由地址
     */
    @Column("path")
    private String path;
    /**
     * 图标
     */
    @Column("icon")
    private String icon;
    /**
     * 类型
     */
    @Column("category")
    private String category;
    /**
     * 优先级
     */
    @Column("priority")
    private Integer priority;
    /**
     * 路由名称
     */
    @Column("router")
    private String router;
    /**
     * 组件名称
     */
    @Column("component")
    private String component;
    /**
     * 重定向地址
     */
    @Column("redirect")
    private String redirect;
    /**
     * META设置
     */
    @Column("meta")
    private String meta;
    /**
     * PARAMS设置
     */
    @Column("params")
    private String params;
    /**
     * 服务编码
     */
    @Column("service_codes")
    private String serviceCodes;
    /**
     * 插件编码
     */
    @Column("plugins_code")
    private String pluginsCode;
    /**
     * 插件状态 true为开启/false为关闭
     */
    @Column("plugins_status")
    private Boolean pluginsStatus;
    /**
     * 按钮编码
     */
    @Column("button_code")
    private String buttonCode;
    @IgnoreAll
    private String children;
    @IgnoreAll
    private boolean checked;
    @IgnoreAll
    private List<Permission> childs;
}
