package com.bocloud.sms.entity;

import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.IgnoreAll;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.GenericEntity;
import com.megatron.entity.meta.PKStrategy;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

import java.util.List;

@EqualsAndHashCode(callSuper = true)
@Table("project")
@Data
@AllArgsConstructor
@NoArgsConstructor
public class Project extends GenericEntity {

    /**
     * 项目id
     */
    @PK(PKStrategy.AUTO)
    private Long id;
    /**
     * 项目管理属性
     */
    @Column("visibility")
    private String visibility;
    /**
     * 所属租户id
     */
    @Column("tenant_id")
    private Long tenantId;
    /**
     * 所属业务id
     */
    @Column("business_id")
    private Long businessId;
    /**
     * 所属组织ID
     */
    @Column("depart_id")
    private Long departId;
    /**
     * 所属组织ID绝对路径
     */
    @Column("depart_ids")
    private String departIds;
    /**
     * 项目编码
     */
    @Column("code")
    private String code;
    /**
     * 所属租户名称
     */
    @IgnoreAll
    private String tenantName;
    /**
     * 资源数量
     */
    @IgnoreAll
    private int resourceNum;
    /**
     * 项目经理ID
     */
    @IgnoreAll
    private List<Long> managerIds;
    /**
     * 项目经理名字字符串
     */
    @IgnoreAll
    private String managerName;
    /**
     * 用户数量
     */
    @IgnoreAll
    private Integer userCount;
    /**
     * 所属业务名称
     */
    @IgnoreAll
    private String businessName;
    /**
     * 前端是否选中
     */
    @IgnoreAll
    private Boolean check;
    /**
     * 所属组织名称
     */
    @IgnoreAll
    private String departName;

}
