package com.bocloud.sms.repository;

import com.bocloud.sms.entity.GlobalManConfig;
import com.megatron.common.model.Pager;
import com.megatron.common.model.Param;
import com.megatron.common.utils.Common;
import com.megatron.common.utils.MapTools;
import com.megatron.database.core.intf.impl.BasicGenericDao;
import com.megatron.database.utils.QueryBuilder;
import com.megatron.framework.core.CurrentService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;
import org.springframework.stereotype.Repository;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * @author wpj
 * @since 2022/9/8
 */
@Repository
public class GlobalManConfigRepository extends BasicGenericDao<GlobalManConfig, Long> {

    @Autowired
    public GlobalManConfigRepository(JdbcTemplate jdbcTemplate, NamedParameterJdbcTemplate npJdbcTemplate, CurrentService service) {
        super(jdbcTemplate, npJdbcTemplate, service);
    }

    public int count(List<Param> params) {
        String sql = "select count(1) from global_operation_config ";
        sql = getQueryBuilder().buildRaw(sql, params, null, "");
        Map<String, Object> param = getQueryBuilder().getParam(params);
        return this.countQuery(sql, param).intValue();
    }

    public List<GlobalManConfig> list(Pager pager) {
        String sql = "select a.* from global_operation_config a ";
        sql = getQueryBuilder().build(sql, pager, "a");
        Map<String, Object> paramsMap = getQueryBuilder().getParam(pager.getParams());
        return this.list(GlobalManConfig.class, sql, paramsMap);
    }

    public List<GlobalManConfig> listAll(){
        String sql = "select a.* from global_operation_config a ";
        return this.list(GlobalManConfig.class, sql);
    }

    public boolean existCron(String cron)  {
        String sql = "select a.* from global_operation_config a where a.cron = :cron";
        Map<String, Object> paramsMap = MapTools.simpleMap("cron", cron);
        List<GlobalManConfig> globalManConfigList = this.list(GlobalManConfig.class, sql, paramsMap);
        if (globalManConfigList.isEmpty()) {
            return false;
        }
        return true;
    }

    public GlobalManConfig query(Long id)  {
        String sql = "select a.* from global_operation_config a where a.id = :id";
        Map<String, Object> params = MapTools.simpleMap(Common.ID, id);
        List<GlobalManConfig> globalManConfigList = this.list(GlobalManConfig.class, sql, params);
        if (globalManConfigList.isEmpty()) {
            return null;
        }
        return globalManConfigList.get(0);
    }

}